#!/bin/sh



#cd /builds/OOo_2.0.0rc3_src/ootrans_m3/

LANG=C

cd /home/tenzin/work/openoffice-2.0.4-RC3


for i in `find . -name *.po|sort`
do
   echo $i|sed 's#./##'
   TRANSLATOR=`cat $i | grep Last-Translator`
   echo $TRANSLATOR | sed 's#"Last-Translator: *##' | sed 's#<.*##'

   STATISTICS=`msgfmt --statistics $i 2>&1`

   # Translated
   echo $STATISTICS | grep " translated message" | sed 's# translated message.*##'

   # Fuzzy
   echo $STATISTICS | grep " fuzzy" | sed 's#^.* translated messages*, ##'| sed 's# fuzzy.*##'
   echo $STATISTICS | grep " fuzzy" >/dev/null || echo 0

   # Untranslated
   echo $STATISTICS | grep " untranslated message" | sed 's#^.* translated messages*, ##'| sed 's#.* fuzzy translations*, ##'| sed 's# untranslated message.*##'
   echo $STATISTICS | grep " untranslated message" >/dev/null || echo 0
done | gawk '
BEGIN {
   WIDTH=400

   print "<h2>Statistics of the OOo 2.0  translation for Dzongkha</h2>"
   print "<table cellpadding=0 cellspacing=0>"
}
{
FILENAME=$0
getline; TRANSLATOR=$0
getline; TRANSLATED=$0
getline; FUZZY=$0
getline; UNTRANSLATED=$0

TOTAL=TRANSLATED+FUZZY+UNTRANSLATED;

TOTALTRANSLATED+=TRANSLATED;
TOTALFUZZY+=FUZZY;
TOTALUNTRANSLATED+=UNTRANSLATED;
TOTALTOTAL+=TOTAL;

if ( FILENAME ~ "^helpcontent" ) {
   HELPTRANSLATED+=TRANSLATED;
   HELPFUZZY+=FUZZY;
   HELPUNTRANSLATED+=UNTRANSLATED;
   HELPTOTAL=HELPTOTAL+TRANSLATED+FUZZY+UNTRANSLATED;
} else {
   GUITRANSLATED+=TRANSLATED;
   GUIFUZZY+=FUZZY;
   GUIUNTRANSLATED+=UNTRANSLATED;
   GUITOTAL=GUITOTAL+TRANSLATED+FUZZY+UNTRANSLATED;
}

#This aep hack forces to display ALL the files including the full automatic translated
if (UNTRANSLATED+FUZZY >= 0) {
   FILES++

   if ( FILES%2 == 1) {
     ENTRYBG="#eeeeee"
   } else {
     ENTRYBG="white"
   }

   print  "<tr><td bgcolor=\"" ENTRYBG "\"><font size=\"-2\"><a href=\"po/" FILENAME "\">" FILENAME "</a></font></td>"
   print  "<td  bgcolor=\"" ENTRYBG "\" width="400">"
   printf "<img src=\"imgs/green.png\" height=\"5\" width=\"%d\">", WIDTH*(TRANSLATED/TOTAL)*1.3
   printf "<img src=\"imgs/yellow.png\" height=\"5\" width=\"%d\">", WIDTH*(FUZZY/TOTAL)*1.3
   printf "<img src=\"imgs/red.png\" height=\"5\" width=\"%d\">", WIDTH*(UNTRANSLATED/TOTAL)*1.3
   print  "</td></tr>"

   printf "<tr><td bgcolor=\"" ENTRYBG "\">&nbsp;</td><td bgcolor=\"" ENTRYBG "\"><font size=\"-2\">Translated:<b> %d</b>; Fuzzy:<b> %d</b>; Unstranslated:<b> %d</b>; Translator: <b>%s</b></font></td></tr>", TRANSLATED, FUZZY, UNTRANSLATED, TRANSLATOR
}
}
END {
   print "</table>"
   print "<br><br>" 

   print "<table bgcolor=\"#dddddd\"><tr><td><font size=\"3\">Help</font></td><td width="400">"
   printf "<img src=\"imgs/green.png\" height=\"5\" width=\"%d\">", WIDTH*HELPTRANSLATED/HELPTOTAL
   printf "<img src=\"imgs/yellow.png\" height=\"5\" width=\"%d\">", WIDTH*HELPFUZZY/HELPTOTAL
   printf "<img src=\"imgs/red.png\" height=\"5\" width=\"%d\">", WIDTH*HELPUNTRANSLATED/HELPTOTAL
   print "</td></table>"

   print "<table>"
   printf "<tr><td>Translated:</td><td>%d --</td><td>%d %</td><td><img src=\"imgs/green.png\" height=\"5\" width=\"%d\"></td></tr>", HELPTRANSLATED, 100*HELPTRANSLATED/HELPTOTAL, WIDTH*HELPTRANSLATED/HELPTOTAL
   printf "<tr><td>Fuzzy:</td><td>%d --</td><td>%d %</td><td><img src=\"imgs/yellow.png\" height=\"5\" width=\"%d\"></td></tr>", HELPFUZZY, 100*HELPFUZZY/HELPTOTAL, WIDTH*HELPFUZZY/HELPTOTAL
   printf "<tr><td>Unstranslated:</td><td><b>%d --</b></td><td>%d %</td><td><img src=\"imgs/red.png\" height=\"5\" width=\"%d\"></td></tr>", HELPUNTRANSLATED, 100*HELPUNTRANSLATED/HELPTOTAL, WIDTH*HELPUNTRANSLATED/HELPTOTAL
   print "</table>"
   print "<br>"

   print "<table bgcolor=\"#dddddd\"><tr><td><font size=\"3\">GUI</font></td><td width="400">"
   printf "<img src=\"imgs/green.png\" height=\"5\" width=\"%d\">", WIDTH*GUITRANSLATED/GUITOTAL
   printf "<img src=\"imgs/yellow.png\" height=\"5\" width=\"%d\">", WIDTH*GUIFUZZY/GUITOTAL
   printf "<img src=\"imgs/red.png\" height=\"5\" width=\"%d\">", WIDTH*GUIUNTRANSLATED/GUITOTAL
   print "</td></table>"

   print "<table>"
   printf "<tr><td>Translated:</td><td>%d --</td><td>%d %</td><td><img src=\"imgs/green.png\" height=\"5\" width=\"%d\"></td></tr>", GUITRANSLATED, 100*GUITRANSLATED/GUITOTAL, WIDTH*GUITRANSLATED/GUITOTAL
   printf "<tr><td>Fuzzy:</td><td>%d --</td><td>%d %</td><td><img src=\"imgs/yellow.png\" height=\"5\" width=\"%d\"></td></tr>", GUIFUZZY, 100*GUIFUZZY/GUITOTAL, WIDTH*GUIFUZZY/GUITOTAL
   printf "<tr><td>Unstranslated:</td><td><b>%d --</b></td><td>%d %</td><td><img src=\"imgs/red.png\" height=\"5\" width=\"%d\"></td></tr>", GUIUNTRANSLATED, 100*GUIUNTRANSLATED/GUITOTAL, WIDTH*GUIUNTRANSLATED/GUITOTAL
   print "</table>"
   print "<br>"

   print "<table bgcolor=\"#dddddd\"><tr><td><font size=\"3\">Totals</font></td><td width="400">"
   printf "<img src=\"imgs/green.png\" height=\"5\" width=\"%d\">", WIDTH*TOTALTRANSLATED/TOTALTOTAL
   printf "<img src=\"imgs/yellow.png\" height=\"5\" width=\"%d\">", WIDTH*TOTALFUZZY/TOTALTOTAL
   printf "<img src=\"imgs/red.png\" height=\"5\" width=\"%d\">", WIDTH*TOTALUNTRANSLATED/TOTALTOTAL
   print "</td></table>"

   print "<table>"
   printf "<tr><td>Translated:</td><td>%d --</td><td>%d %</td><td><img src=\"imgs/green.png\" height=\"5\" width=\"%d\"></td></tr>", TOTALTRANSLATED, 100*TOTALTRANSLATED/TOTALTOTAL, WIDTH*TOTALTRANSLATED/TOTALTOTAL
   printf "<tr><td>Fuzzy:</td><td>%d --</td><td>%d %</td><td><img src=\"imgs/yellow.png\" height=\"5\" width=\"%d\"></td></tr>", TOTALFUZZY, 100*TOTALFUZZY/TOTALTOTAL, WIDTH*TOTALFUZZY/TOTALTOTAL
   printf "<tr><td>Untranslated:</td><td><b>%d --</b></td><td>%d %</td><td><img src=\"imgs/red.png\" height=\"5\" width=\"%d\"></td></tr>", TOTALUNTRANSLATED, 100*TOTALUNTRANSLATED/TOTALTOTAL, WIDTH*TOTALUNTRANSLATED/TOTALTOTAL
   print "</table>"
   print "<br>"

}' > /home/tenzin/work/status/index_ooo-2.0.4-RC3.html

(
   echo "<p>Update: <font size=\"-3\">"
   LANG=C date
   echo "</font></p>"
   echo "</body></html>"
) >> /home/tenzin/work/status/index_ooo-2.0.4-RC3.html
   
rm messages.mo
